Bug 548826 - gcc hangs during compilation
gcc hangs during compilation
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
i686 Linux
low Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2009-12-18 13:14 EST by tom fogal
Modified: 2010-03-11 18:18 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2010-03-11 18:18:36 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
The preprocessed output of g++ -E ... ImageVis3D_WindowHandling.cpp (2.94 MB, text/plain)
2009-12-18 13:14 EST, tom fogal
no flags Details

  None (edit)
Description tom fogal 2009-12-18 13:14:36 EST
Created attachment 379264 [details]
The preprocessed output of g++ -E ... ImageVis3D_WindowHandling.cpp

Description of problem:

The 'ImageVis3D' program fails to compile; one source file seems to cause the compiler to enter an infinite loop.

Version-Release number of selected component (if applicable):

This is in fedora12, gcc 4.4.2-7.

How reproducible: 100% of the time

Steps to Reproduce:
1. checkout imagevis3d: 'svn co https://gforge.sci.utah.edu/svn/imagevis3d'.  There are multiple sub-repositories (externals) that you'll need to confirm the security fingerprint for.
2. Make sure qt-devel is installed and qmake is in your path
3. cd imagevis3d
4. sh Scripts/unix-dev-cfg.sh
5. make
Actual results:

Compilation stalls at ImageVis3D_WindowHandling.cpp.  I gave it significant time to get through this before giving up:

   real	   920m33.774s
   user	   2m1.465s
   sys     4m1.191s

Additional info: The preprocessed source output is attached.
Comment 1 tom fogal 2009-12-29 20:56:31 EST
I apologize.  Step 4 has changed to:

  sh Scripts/gcc-dev-cfg.sh

in latest trunk.

Secondly, I have upgraded to:

  gcc version 4.4.2 20091222 (Red Hat 4.4.2-20) (GCC)

and in this version I can confirm that this is related to the optimization level.  qmake's default configuration ends up adding "-O2" to the build options; if I manually change this to "-O0", the compilation completes in 4 seconds.

This may be a duplicate of 531218.
Comment 2 Jakub Jelinek 2010-01-13 04:04:32 EST
Please try http://kojipkgs.fedoraproject.org/packages/gcc/4.4.2/24.fc12/
Comment 3 tom fogal 2010-01-13 23:17:54 EST
No dice.  Using:

   gcc version 4.4.2 20100112 (Red Hat 4.4.2-24) (GCC)

it still hangs on 'ImageVis3D_WindowHandling.cpp'.  "-O0" is still a valid workaround.  I'll also note that "-O1" seems to cause the issue as well.
Comment 4 Jakub Jelinek 2010-01-14 04:24:17 EST
I guess I'll resurrect the gcc44-max-vartrack-size.patch, but this time with a 50000000 default instead of 5000000.  That way it shouldn't trigger on reasonably sized testcases and will only trigger on these monsters.
Comment 5 Jakub Jelinek 2010-02-11 11:52:50 EST
Please try gcc-4.4.3-4.fc12.
Comment 6 tom fogal 2010-03-11 18:18:36 EST
I apologize for the delay.  Compilation succeeds on a fresh+updated FC12 install (gcc-4.4.3-4).  Thanks!

I do get a:

  note: variable tracking size limit exceeded with debug insns, retrying without

but from comments it sounds like this is by design.

Note You need to log in before you can comment on or make changes to this bug.